Angular Grid - Angular | www.HtmlElements.com


Angular Grid


The Grid solution for Angular Enterprise Applications with 14 Material Themes and 100+ Angular Grid Demos.

  • Grouping
  • Filtering
  • Sorting
  • Editing
  • Paging
  • Selection
  • Outstanding Performance
  • Masted Detail
  • Export to Excel, PDF, CSV, TSV, HTML, JSON
  • Import from Excel
  • Cut, Copy, Paste
  • Auto-Fill
  • Merged Cells
  • Printing
  • Lazy Load
  • Server side operation
  • 80%+ code coverage with Tests
  • Industry best Accessibility support
  • Localization, I18n, RTL
  • Tree Data



Angular Grid Project Tracker Example


Overview


We will walk you through the steps to add Smart.Grid to an Angular project, and configure some of the features. Smart.Grid is a feature complete data grid component with enterprise-grade features. We will show you some of the data grid capabilities (properties, data source). In addition, we will customize the Grid appearance with custom Column Templates. If you would like to move directly to our examples, please navigate to Angular Grid Demos.



Table of Contents

Add Grid to Your Angular Project

The Angular step we need to take to make Angular display the smart-grid is to import the GridModule.
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';

import { AppComponent } from './app.component';
import { GridModule } from 'smart-webcomponents-angular/grid';

@NgModule({
    declarations: [AppComponent],
    imports: [BrowserModule, FormsModule, GridModule],
    schemas: [],
    providers: [],
    bootstrap: [AppComponent]
})

export class AppModule { }

We can now use the smart-grid with Angular. Data binding and event handlers will just work right out of the box.
Here’s how we would use our Smart.Grid element as part of a simple Angular app. First, our component template:

app.component.html

 <smart-grid [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 

We have bound the "columns" and "dataSource" properties of the smart-grid to values in our Angular component.

app.component.ts

import { Component, ViewChild, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { GridComponent, GridColumn, DataAdapter, Smart } from 'smart-webcomponents-angular/grid';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements AfterViewInit {
	dataSource = new Smart.DataAdapter(
		{
			dataSource: [{ "id": 0, "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte", "price": 3.8, "quantity": 6, "total": 22.799999999999997 }, { "id": 1, "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte", "price": 3.8, "quantity": 8, "total": 30.4 }, { "id": 2, "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea", "price": 1.5, "quantity": 2, "total": 3 }, { "id": 3, "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte", "price": 3.8, "quantity": 2, "total": 7.6 }, { "id": 4, "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna", "price": 3.25, "quantity": 4, "total": 13 }, { "id": 5, "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano", "price": 2.5, "quantity": 4, "total": 10 }, { "id": 6, "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte", "price": 3.8, "quantity": 8, "total": 30.4 }, { "id": 7, "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano", "price": 2.5, "quantity": 6, "total": 15 }, { "id": 8, "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna", "price": 3.25, "quantity": 3, "total": 9.75 }, { "id": 9, "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea", "price": 1.5, "quantity": 9, "total": 13.5 }, { "id": 10, "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle", "price": 1.75, "quantity": 6, "total": 10.5 }, { "id": 11, "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist", "price": 4, "quantity": 11, "total": 44 }],
			dataFields:
				[
					'id: number',
					'firstName: string',
					'lastName: string',
					'productName: string',
					'quantity: number',
					'price: number',
					'total: number'
				]
		})
		
		
	columns: GridColumn[] = [
		{
			label: 'First Name', dataField: 'firstName', columnGroup: 'name'
		},
		{ label: 'Last Name', dataField: 'lastName', columnGroup: 'name' },
		{ label: 'Product', dataField: 'productName', columnGroup: 'order' },
		{ label: 'Quantity', dataField: 'quantity', columnGroup: 'order' },
		{
			label: 'Unit Price', dataField: 'price', cellsFormat: 'c2', columnGroup: 'order', formatFunction(settings) {
				const rowId = settings.row;
				const columnDataField = settings.column;
				const template = settings.template;
				const cell = settings.cell!;
				
				if (settings.value >= 4) {
					cell.background = '#00A45A';
					cell.color = '#fff';
				}
				else if (settings.value < 2) {
					cell.background = '#DF3800';
					cell.color = '#fff';
				}
				else {
					cell.background = '#FFFDE1';
					cell.color = '#333';
				}

				settings.value = '$' + new Number(settings.value).toFixed(2);
			}
		},
		{
			label: 'Total', dataField: 'total', cellsFormat: 'c2', columnGroup: 'order', formatFunction(settings) {
				const rowId = settings.row;
				const columnDataField = settings.column;
				const template = settings.template;
				const cell = settings.cell!;
			
				if (settings.value >= 20) {
					cell.background = '#00A45A';
					cell.color = '#fff';
				}
				else if (settings.value <= 5) {
					cell.background = '#DF3800';
					cell.color = '#fff';
				}
				else {
					cell.background = '#FFFDE1';
					cell.color = '#333';
				}

				settings.value = '$' + new Number(settings.value).toFixed(2);
			}
		}
	]	
	
    ngOnInit(): void {

    }
    ngAfterViewInit(): void {
    }
}

angular.json

The below code is the angular.json file, where we updated the "styles" by adding the CSS file for the Smart Web Components.
{
  "$schema": "./node_modules/@angular/cli/lib/config/schema.json",
  "version": 1,
  "newProjectRoot": "projects",
  "projects": {
    "bargauge": {
      "projectType": "application",
      "root": "",
      "architect": {
        "build": {
          "builder": "@angular-devkit/build-angular:browser",
          "options": {
            "outputPath": "dist/grid/overview/",
            "index": "",
            "main": "src/grid/overview//main.ts",
            "polyfills": "polyfills.ts",
            "tsConfig": "tsconfig.app.json",
			"styles": [
				"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
			],
			"es5BrowserSupport": false
          },	
          "configurations": {
            "production": {
              "optimization": true,
              "sourceMap": false,
              "extractCss": true,
              "namedChunks": false,
              "aot": true,
              "extractLicenses": false,
              "vendorChunk": false,
              "buildOptimizer": true
            }
          }
        }
      }
    }
  }
}

Result:

Angular Grid Web Component

Add Sorting and Filtering


Sorting and Filtering are essential features in each web application with Grids. To enable the sorting and filtering in our grid, we need to define two objects - sorting and filtering and set the "enabled" boolean property to true. We add the below code to app.component.ts

	sorting = {
		enabled: true;
	}
	
	filtering = {
		enabled: true;
	}

and in app.component.html

 <smart-grid [sorting]="sorting" [filtering]="filtering" [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 


Online Examples: Grid Sorting and Grid Filtering

Enable Selection


The Grid supports selection by cell, row and with checkboxes. We can also choose from selection with single and double-click, selection by one or multiple rows or cells. In the code below, we will enable the Row selection. We add the below code to app.component.ts

	selection = {
		enabled: true;
	}

and in app.component.html

 <smart-grid [selection]="selection" [sorting]="sorting" [filtering]="filtering" [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 


Online Selection Example: Grid Selection.


Enable Grouping


Grouping is a professional feature and requires a license. The comparison table with features and components included in the Community and Professional versions is here. Similar to Sorting and Filtering, Grouping is enabled by setting the "enabled" property to true

We add the below code to app.component.ts

	grouping = {
		enabled: true;
	}

and in app.component.html

 <smart-grid [grouping]="grouping" [selection]="selection" [sorting]="sorting" [filtering]="filtering" [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 

Angular Grid Web Component Grouping

Online Grouping Example: Grid Grouping.



Enable Paging


smart-grid supports editing by cell, editing by row(Professional) and editing with dialog or command column(Professional). In this case, we will use the cell editing. You can enable the editing functionality by setting the "enabled" boolean property to true.

app.component.ts

import { Component, ViewChild, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { GridComponent, GridColumn, DataAdapter, Smart } from 'smart-webcomponents-angular/grid';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements AfterViewInit {
	editing = {
		enabled: true
	}
		
	dataSource = new Smart.DataAdapter(
		{
			dataSource: [{ "id": 0, "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte", "price": 3.8, "quantity": 6, "total": 22.799999999999997 }, { "id": 1, "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte", "price": 3.8, "quantity": 8, "total": 30.4 }, { "id": 2, "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea", "price": 1.5, "quantity": 2, "total": 3 }, { "id": 3, "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte", "price": 3.8, "quantity": 2, "total": 7.6 }, { "id": 4, "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna", "price": 3.25, "quantity": 4, "total": 13 }, { "id": 5, "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano", "price": 2.5, "quantity": 4, "total": 10 }, { "id": 6, "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte", "price": 3.8, "quantity": 8, "total": 30.4 }, { "id": 7, "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano", "price": 2.5, "quantity": 6, "total": 15 }, { "id": 8, "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna", "price": 3.25, "quantity": 3, "total": 9.75 }, { "id": 9, "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea", "price": 1.5, "quantity": 9, "total": 13.5 }, { "id": 10, "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle", "price": 1.75, "quantity": 6, "total": 10.5 }, { "id": 11, "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist", "price": 4, "quantity": 11, "total": 44 }],
			dataFields:
				[
					'id: number',
					'firstName: string',
					'lastName: string',
					'productName: string',
					'quantity: number',
					'price: number',
					'total: number'
				]
		})
		
		
	columns: GridColumn[] = [
		{
			label: 'First Name', dataField: 'firstName', columnGroup: 'name'
		},
		{ label: 'Last Name', dataField: 'lastName', columnGroup: 'name' },
		{ label: 'Product', dataField: 'productName', columnGroup: 'order' },
		{ label: 'Quantity', dataField: 'quantity', columnGroup: 'order' },
		{
			label: 'Unit Price', dataField: 'price', cellsFormat: 'c2'
		},
		{
			label: 'Total', dataField: 'total', cellsFormat: 'c2'
		}
	]	
	
    ngOnInit(): void {

    }
    ngAfterViewInit(): void {
    }
}


app.component.html

 <smart-grid [editing]="editing" [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 


Enable Paging


To enable pagination, set the grid paging and pager properties. The paging.enabled turns on/off pagination, pager.visible shows/hides the top or bottom pagers. The grid's pagination feature can be used to load data on demand. It can be used with all other grid features. There are built-in options to customize the "pageSize", navigate through pages using API, customize the pager's template, configure whether top and bottom pagers are visible all the time or only the top or bottom pager is visible. It is also optional to display a "select" tag to dynamically update the page size or an "input" tag which allows you to type the page index and navigate to the page.

app.component.ts

import { Component, ViewChild, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { GridComponent, GridColumn, DataAdapter, Smart } from 'smart-webcomponents-angular/grid';
@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements AfterViewInit {
	@ViewChild("grid", { read: GridComponent, static: false }) grid!: GridComponent;

	editing = {
		enabled: true
	}
	
	paging = {
		enabled: true,
		pageSize: 5
	}
	
	pager = {
		visible: true
	}
	
	dataSource = new Smart.DataAdapter(
		{{
			dataSource: [{ "id": 0, "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte", "price": 3.8, "quantity": 6, "total": 22.799999999999997 }, { "id": 1, "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte", "price": 3.8, "quantity": 8, "total": 30.4 }, { "id": 2, "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea", "price": 1.5, "quantity": 2, "total": 3 }, { "id": 3, "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte", "price": 3.8, "quantity": 2, "total": 7.6 }, { "id": 4, "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna", "price": 3.25, "quantity": 4, "total": 13 }, { "id": 5, "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano", "price": 2.5, "quantity": 4, "total": 10 }, { "id": 6, "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte", "price": 3.8, "quantity": 8, "total": 30.4 }, { "id": 7, "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano", "price": 2.5, "quantity": 6, "total": 15 }, { "id": 8, "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna", "price": 3.25, "quantity": 3, "total": 9.75 }, { "id": 9, "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea", "price": 1.5, "quantity": 9, "total": 13.5 }, { "id": 10, "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle", "price": 1.75, "quantity": 6, "total": 10.5 }, { "id": 11, "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist", "price": 4, "quantity": 11, "total": 44 }],
			dataFields:
				[
					'id: number',
					'firstName: string',
					'lastName: string',
					'productName: string',
					'quantity: number',
					'price: number',
					'total: number'
				]
		})
		
		
	columns: GridColumn[] = [
		{
			label: 'First Name', dataField: 'firstName', columnGroup: 'name'
		},
		{ label: 'Last Name', dataField: 'lastName', columnGroup: 'name' },
		{ label: 'Product', dataField: 'productName', columnGroup: 'order' },
		{ label: 'Quantity', dataField: 'quantity', columnGroup: 'order' },
		{
			label: 'Unit Price', dataField: 'price', cellsFormat: 'c2'
		},
		{
			label: 'Total', dataField: 'total', cellsFormat: 'c2'
		}
	]	
	
    ngOnInit(): void {

    }
    ngAfterViewInit(): void {
    }
}


app.component.html

 <smart-grid [paging]="paging" [pager]="pager" [editing]="editing" [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 


Set Theme


The Smart Web Components product includes 14 Material Themes - 7 Light and 7 Dark. To set a theme, just include the "smart.[theme].css" file after smart.default.css and set your component's theme attribute to the theme name.

 <smart-grid [theme]="'dark'" [grouping]="grouping" [selection]="selection" [sorting]="sorting" [filtering]="filtering" [columns]="columns" [dataSource]="dataSource" id="grid"></smart-grid> 

Angular Grid Web Component Dark

If you would like to customize or build a custom theme, you can use our Online Theme Builder web application.

Angular Grid Demos


You can look at our collection of demos about the Grid Component here; Angular Grid Demos. There you will find a demo about Filtering, Sorting, Editing, Selection, Print, Export to Excel, PDF, Import from Excel and more.

Example

React - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

React & Smart UI


React provides a declarative library that keeps the DOM in sync with your data. This page explains how to use Smart UI Grid with React.



Overview


We will walk you through the steps to add Smart UI to an existing React project, and configure some of the features. Smart UI contains 60+ Components with Material Design. Some of the web components are: Grid, Chart, Gannt Chart, Docking Layout. For the purposes of the demo, we will use the Grid component. We will show you some of the data grid capabilities (properties, data source). In addition, we will customize the Grid appearance with custom Column Templates.



Smart.Grid

The Smart UI Grid component is a DataGrid(Table) component. The Grid supports loading of large amounts of data, scrolling, paging, load-on-demand, tree list rendering, spreadsheet rendering, keyboard navigation, CRUD, sort by one or many columns, filtering with filter menu, filter row or filter toolbar, data grouping with summaries with several rendering modes, editing by cell, row, dialog, command columns. Batch Editing, built-in Validation for fields. Built-in security with customizable HTML Tags Escape. You can choose whether to escape all html tags or a black list of tags like: 'script', 'object', etc. The grid comes with many available styling options, Material UI & Bootstrap themes which allow you to quickly build eye-catching, high-performance web apps. It is the most feature-complete Grid component available on the market.
The Smart.Grid component for React has built-in data binding capabilities and supports Client and server-side model. It can be bound to Local Data, JSON, XML, CSV, TSV, Remote Data (JSONP) and Virtual Data where data is loaded on demand. In order to bind the Grid to a data source you need to set its source property to point to an instance of Smart.DataAdapter and configure the adapter as demonstrated in our docs & examples. You can read more about Smart.Grid here. For React Grid demos, visit: Grid demos.



Table of Contents

Add "smart-grid" to Your React Project


We will use the 'create-react-app' react application as a starting point.

Getting Started with React Grid Component

Setup React Environment

The easiest way to start with React is to use create-react-app. To scaffold your project structure, follow the installation instructions.

npx create-react-app my-app
cd my-app
npm start

Preparation

Open src/App.js andsrc/App.css

  1. Remove everything inside the App div tag in src/App.js:
    <div className="App"> </div>
  2. Remove the logo.svg import
  3. Remove the contents of src/App.css
  4. Remove src/logo.svg

Setup the Grid

Smart UI for React is distributed as smart-webcomponents-react NPM package

  1. Download and install the package.
    npm install smart-webcomponents-react
  2. Once installed, import the React Grid Component and CSS files in your application and render it Open src/App.js in your favorite text editor and change its contents to the following:

    App.js

    import 'smart-webcomponents-react/source/styles/smart.default.css';
    import React from "react";
    import { Smart, Grid } from 'smart-webcomponents-react/grid';
    
    const App = () => {
    	const dataSource = new Smart.DataAdapter({
    	dataSource: [  
    		  { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
    		  { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
    		  { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
    		  { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
    		  { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
    		  { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
    		  { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
    		  { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
    		  { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
    		  { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
    		  { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
    		  { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
    		  { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
    	 ],  
    		dataFields: [
    			'firstName: string',
    			'lastName: string',
    			'productName: string'
    		]
    	})
    
    	const columns = [{
    		label: 'First Name',
    		dataField: 'firstName'
    	},
    	{
    		label: 'Last Name',
    		dataField: 'lastName'
    	},
    	{
    		label: 'Product',
    		dataField: 'productName'
    	}
    	]
    
    	return (
    		<div>
    			<Grid
    				dataSource={dataSource}
    				columns={columns}
    				>
    			</Grid>
    		</div>
    	);
    }
    
    export default App;
    
    We can now use the smart-grid with React. Data binding and event handlers will just work right out of the box.
    We have bound the "columns" and "dataSource" properties of the smart-grid to values in our React component.


    Add Sorting and Filtering


    Sorting and Filtering are essential features in each web application with Grids. To enable the sorting and filtering in our grid, we need to define two objects - sorting and filtering and set the "enabled" boolean property to true. We add the below code to the Smart function defined in the App.js

    import React from "react";
    import ReactDOM from "react-dom";
    import 'smart-webcomponents-react/source/styles/smart.default.css';
    import { Smart, Grid } from 'smart-webcomponents-react/grid';
    
    class App extends React.Component {
    	behavior = {
    		columnResizeMode: 'growAndShrink'
    	}
    
    	appearance = {
    		alternationCount: 2,
    		showRowHeader: true,
    		showRowHeaderSelectIcon: true,
    		showRowHeaderFocusIcon: true
    	}
    
    	paging = {
    		enabled: true
    	}
    
    	pager = {
    		visible: true
    	}
    
    	sorting = {
    		enabled: true
    	}
    
    	editing = {
    		enabled: true
    	}
    	
    	filtering = {
    		enabled: true
    	}
    
    	dataSource = new Smart.DataAdapter({
    	dataSource: [  
    		  { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
    		  { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
    		  { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
    		  { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
    		  { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
    		  { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
    		  { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
    		  { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
    		  { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
    		  { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
    		  { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
    		  { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
    		  { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
    	 ],  
    		dataFields: [
    			'firstName: string',
    			'lastName: string',
    			'productName: string'
    		]
    	})
    
    	columns = [{
    		label: 'First Name',
    		dataField: 'firstName'
    	},
    	{
    		label: 'Last Name',
    		dataField: 'lastName'
    	},
    	{
    		label: 'Product',
    		dataField: 'productName'
    	}
    	]
    
    	componentDidMount() {
    
    	}
    
    	render() {
    		return (
    			<div>
    				<Grid
    					dataSource={this.dataSource}
    					columns={this.columns}
    					appearance={this.appearance}
    					behavior={this.behavior}
    					paging={this.paging}
    					pager={this.pager}
    					filtering={this.filtering}
    					sorting={this.sorting}
    					editing={this.editing}
    					>
    				</Grid>
    			</div>
    		);
    	}
    }
    
    export default App;
    

    React Grid Sort and Filter



    Enable Selection


    The Grid supports selection by cell, row and with checkboxes. We can also choose from selection with single and double-click, selection by one or multiple rows or cells. In the code below, we will enable the Row selection. We add the below code to the Smart funtion App.js

    	selection = {
    		enabled: true
    	}
    



    Add Grouping


    Similar to Sorting and Filtering, Grouping is enabled by setting the "enabled" property to true

    We add the below code to App.js

    	grouping = {
    		enabled: true
    	}
    

    App.js

    import React from "react";
    import ReactDOM from "react-dom";
    import 'smart-webcomponents-react/source/styles/smart.default.css';
    import { Smart, Grid } from 'smart-webcomponents-react/grid';
    
    class App extends React.Component {
    	behavior = {
    		columnResizeMode: 'growAndShrink'
    	}
    
    	appearance = {
    		alternationCount: 2,
    		showRowHeader: true,
    		showRowHeaderSelectIcon: true,
    		showRowHeaderFocusIcon: true
    	}
    
    	grouping = {
    		enabled: true
    	}
    
    	sorting = {
    		enabled: true
    	}
    
    	editing = {
    		enabled: true
    	}
    
    	dataSource = new Smart.DataAdapter({
    	dataSource: [  
    		  { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
    		  { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
    		  { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
    		  { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
    		  { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
    		  { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
    		  { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
    		  { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
    		  { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
    		  { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
    		  { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
    		  { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
    		  { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
    	 ],  
    		dataFields: [
    			'firstName: string',
    			'lastName: string',
    			'productName: string'
    		]
    	})
    
    	columns = [{
    		label: 'First Name',
    		dataField: 'firstName'
    	},
    	{
    		label: 'Last Name',
    		dataField: 'lastName'
    	},
    	{
    		label: 'Product',
    		dataField: 'productName'
    	}
    	]
    
    	componentDidMount() {
    
    	}
    
    	render() {
    		return (
    			<div>
    				<Grid
    					dataSource={this.dataSource}
    					columns={this.columns}
    					appearance={this.appearance}
    					behavior={this.behavior}
    					grouping={this.grouping}
    					sorting={this.sorting}
    					>
    				</Grid>
    			</div>
    		);
    	}
    }
    
    export default App;
    
    React Grid Web Component Grouping





    Enable Editing


    smart-grid supports editing by cell, editing by row and editing with dialog or command column. In this case, we will use the cell editing. You can enable the editing functionality by setting the "enabled" boolean property to true.

    App.js

    	editing = {
    		enabled: true
    	}
    	
    		render() {
    		return (
    			<div>
    				<Grid
    					dataSource={this.dataSource}
    					columns={this.columns}
    					appearance={this.appearance}
    					behavior={this.behavior}
    					grouping={this.grouping}
    					sorting={this.sorting}
    					editing={this.editing}
    					>
    				</Grid>
    			</div>
    		);
    	}
    


    Enable Paging


    To enable pagination, set the grid paging and pager properties. The paging.enabled turns on/off pagination, pager.visible shows/hides the top or bottom pagers. The grid's pagination feature can be used to load data on demand. It can be used with all other grid features. There are built-in options to customize the "pageSize", navigate through pages using API, customize the pager's template, configure whether top and bottom pagers are visible all the time or only the top or bottom pager is visible. It is also optional to display a "select" tag to dynamically update the page size or an "input" tag which allows you to type the page index and navigate to the page.

    App.js

    import React from "react";
    import ReactDOM from "react-dom";
    import 'smart-webcomponents-react/source/styles/smart.default.css';
    import { Smart, Grid } from 'smart-webcomponents-react/grid';
    
    class App extends React.Component {
    	behavior = {
    		columnResizeMode: 'growAndShrink'
    	}
    
    	appearance = {
    		alternationCount: 2,
    		showRowHeader: true,
    		showRowHeaderSelectIcon: true,
    		showRowHeaderFocusIcon: true
    	}
    
    	paging = {
    		enabled: true
    	}
    
    	pager = {
    		visible: true
    	}
    
    	sorting = {
    		enabled: true
    	}
    
    	editing = {
    		enabled: true
    	}
    	
    	filtering = {
    		enabled: true
    	}
    
    	dataSource = new Smart.DataAdapter({
    	dataSource: [  
    		  { "firstName": "Beate", "lastName": "Wilson", "productName": "Caramel Latte"},   
    		  { "firstName": "Ian", "lastName": "Nodier", "productName": "Caramel Latte"},   
    		  { "firstName": "Petra", "lastName": "Vileid", "productName": "Green Tea"},   
    		  { "firstName": "Mayumi", "lastName": "Ohno", "productName": "Caramel Latte"},   
    		  { "firstName": "Mayumi", "lastName": "Saylor", "productName": "Espresso con Panna"},   
    		  { "firstName": "Regina", "lastName": "Fuller", "productName": "Caffe Americano" },  
    		  { "firstName": "Regina", "lastName": "Burke", "productName": "Caramel Latte"},   
    		  { "firstName": "Andrew", "lastName": "Petersen", "productName": "Caffe Americano"},  
    		  { "firstName": "Martin", "lastName": "Ohno", "productName": "Espresso con Panna"},   
    		  { "firstName": "Beate", "lastName": "Devling", "productName": "Green Tea"},   
    		  { "firstName": "Sven", "lastName": "Devling", "productName": "Espresso Truffle"},  
    		  { "firstName": "Petra", "lastName": "Burke", "productName": "Peppermint Mocha Twist"},  
    		  { "firstName": "Marco", "lastName": "Johnes", "productName": "Caffe Mocha"}  
    	 ],  
    		dataFields: [
    			'firstName: string',
    			'lastName: string',
    			'productName: string'
    		]
    	})
    
    	columns = [{
    		label: 'First Name',
    		dataField: 'firstName'
    	},
    	{
    		label: 'Last Name',
    		dataField: 'lastName'
    	},
    	{
    		label: 'Product',
    		dataField: 'productName'
    	}
    	]
    
    	componentDidMount() {
    
    	}
    
    	render() {
    		return (
    			<div>
    				<Grid
    					dataSource={this.dataSource}
    					columns={this.columns}
    					appearance={this.appearance}
    					behavior={this.behavior}
    					paging={this.paging}
    					pager={this.pager}
    					filtering={this.filtering}
    					sorting={this.sorting}
    					editing={this.editing}
    					>
    				</Grid>
    			</div>
    		);
    	}
    }
    
    export default App;
    


    Set Theme


    The Smart Web Components product includes 14 Material Themes - 7 Light and 7 Dark. To set a theme, just include the "smart.[theme].css" file after smart.default.css and set your component's theme attribute to the theme name.


    React Grid Web Component Dark

    If you would like to customize or build a custom theme, you can use our Online Theme Builder web application.

    Summary


    You just learned how to setup an React project and add a Grid Web Component with Sorting, Filtering, Grouping and Selection.